$LOAD_PATH.unshift File.expand_path('../../lib', __FILE__)
require "ostruct"
require 'markdaver'
require "markdaver/inject_index_script"
require "markdaver/markdown_editor_env"

FILE = ENV['MARKDOWN'] || ENV['FILE_TO_OPEN'] || './omg.md'

app = Rack::Builder.new do
  environment = Markdaver::MarkdownEditorEnv.new(
    root_path: File.expand_path("../markdown-editor/"),
    script_file: File.expand_path("./web/script.js"),
    file_to_open: FILE
  )

  map '/save' do
    run ->(env) {
      request = Rack::Request.new(env)
      # TODO:
      #   - add some specs!!!
      #   - store the edition history (create a file for each update?)
      #   - save after some seconds of inactivity
      #   - ...
      File.write FILE, request.params['markdown']
      [200, {'Content-Type' => 'text/plain'}, ['post received!']]
    }
  end

  use Markdaver::InjectIndexScript, markdown_editor_env: environment
  use Rack::Static, urls: [''], root: environment.root_path, index: 'index.html'
  run ->(env) { [200, {'Content-Type' => 'text/plain'}, ['hi there']] }
end

run app
