module Markdaver
  class MarkdownEditorEnv
    attr_reader :root_path

    def initialize(
      root_path: File.expand_path("../../../markdown-editor/"),
      script_file: nil,
      file_to_open: nil
    )
      @root_path = root_path
      @script_file = script_file
      @file_to_open = file_to_open
    end

    def index
      @index ||= File.read(File.join @root_path, "index.html")
        .gsub(/<\/body>/, "\n<script>#{script}</script>\\0")
    end

    private

    def script
      javascript_code = ''
      if @file_to_open and File.exist?(@file_to_open)
        javascript_code << %{ var openFile = `#{File.read(@file_to_open)}`; }
      end
      javascript_code + script_load
    end

    def script_load
      (@script_file && File.read(@script_file)) ||
        %{console.log("we need some script in the environment");}
    end
  end
end
